import matplotlib.pyplot as plt
from matplotlib import cm
import numpy as np

Longueur=1
duree=1000
Nx=100 #valeur paire
Nt=5000
h=Longueur/Nx
k=duree/Nt
al=0.0001
Tinit=10

T=np.zeros((Nt+1,Nx+1))
#une barre froide et une chaude
T[0,((Nx//2)+1):]=Tinit
T[0,((Nx)//2)]=Tinit/2
#température forcée à gauche et à droite
T[:,-1]=Tinit

for t in range(0,Nt):
	for x in range(1,Nx):
		T[t+1,x]=T[t,x]+al*k*(T[t,x+1]-2*T[t,x]+T[t,x-1])/(h*h)
#
dist=np.linspace(0,Longueur,Nx+1) 
#
plt.figure(1)
#plt.imshow(T,cmap=cm.binary,alpha=1)
#alpha=0 transparent; alpha=1 opaque.
#plt.imshow(T,cmap=cm.bwr,alpha=1)
plt.imshow(T)
plt.colorbar()
plt.axis('tight')
plt.ylabel(u'temps (indice)',fontsize=14)
plt.xlabel('longeur (indice)',fontsize=14)
plt.show()
#
plt.figure(2)
plt.plot(dist,T[0],'b-',linewidth=2,label='t=0s')
plt.plot(dist,T[Nt//8],'g-',linewidth=2,label='t='+str(duree/8)+'s')
plt.plot(dist,T[Nt//4],'r-',linewidth=2,label='t='+str(duree/4)+'s')
plt.plot(dist,T[Nt//2],'m-',linewidth=2,label='t='+str(duree/2)+'s')
plt.plot(dist,T[len(T)-1],'k-',linewidth=2,label='t='+str(duree)+'s')
plt.xlabel('longueur (m)',fontsize=14)
plt.ylabel('temperature (°C)',fontsize=14)
plt.legend(loc=2)
plt.show()
